Attribute VB_Name = "common"
' Modem Status Flags
Public Const MS_CTS_ON     As Long = &H10 ' CTSON
Public Const MS_DSR_ON     As Long = &H20 ' DSRON
Public Const MS_RING_ON    As Long = &H40 ' RINGON
Public Const MS_RLSD_ON    As Long = &H80 ' RLSDON

' Action Event
Public Const EVEVT_START    As Long = &H0 ' ʐMJnOANV
Public Const EVEVT_STOP     As Long = &H1 ' ʐM~ANV
Public Const EVEVT_SIGNAL   As Long = &H2 ' ʐM̃VOi

' Action Error
Public Const ERR_NONE          As Long = &H0 ' G[Ȃ
Public Const ERR_CANCEL        As Long = &H1 ' [U[LZŏI
Public Const ERR_ERROR         As Long = &H80000000 ' ̑G[
Public Const ERR_COM_IS_DEAD   As Long = &H80000001 ' COM|[gs
Public Const ERR_LINE_BREAK    As Long = &H80000002 ' f

' Baud
Public Const CBR_110      As Long = 110
Public Const CBR_300      As Long = 300
Public Const CBR_600      As Long = 600
Public Const CBR_1200     As Long = 1200
Public Const CBR_2400     As Long = 2400
Public Const CBR_4800     As Long = 4800
Public Const CBR_9600     As Long = 9600
Public Const CBR_14400    As Long = 14400
Public Const CBR_19200    As Long = 19200
Public Const CBR_38400    As Long = 38400
Public Const CBR_56000    As Long = 56000
Public Const CBR_57600    As Long = 57600
Public Const CBR_115200   As Long = 115200
Public Const CBR_128000   As Long = 128000
Public Const CBR_256000   As Long = 256000

' Flow Control
Public Const FLOW_NONE      As Long = &H0 ' Ȃ
Public Const FLOW_HARDWARE  As Long = &H1 ' n[hEFA
Public Const FLOW_XONOFF    As Long = &H2 ' XON/XOFF

' Parity
Public Const NOPARITY       As Long = 0
Public Const ODDPARITY      As Long = 1
Public Const EVENPARITY     As Long = 2
Public Const MARKPARITY     As Long = 3
Public Const SPACEPARITY    As Long = 4

' Stop Bits
Public Const ONESTOPBIT     As Long = 0
Public Const ONE5STOPBITS   As Long = 1
Public Const TWOSTOPBITS    As Long = 2

Public Function GetBaudRate(index As Long) As Long

    GetBaudRate = CBR_9600
    
    If index = 0 Then
        GetBaudRate = CBR_110
    ElseIf index = 1 Then
        GetBaudRate = CBR_300
    ElseIf index = 2 Then
        GetBaudRate = CBR_600
    ElseIf index = 3 Then
        GetBaudRate = CBR_1200
    ElseIf index = 4 Then
        GetBaudRate = CBR_2400
    ElseIf index = 5 Then
        GetBaudRate = CBR_4800
    ElseIf index = 6 Then
        GetBaudRate = CBR_9600
    ElseIf index = 7 Then
        GetBaudRate = CBR_14400
    ElseIf index = 8 Then
        GetBaudRate = CBR_19200
    ElseIf index = 9 Then
        GetBaudRate = CBR_38400
    ElseIf index = 10 Then
        GetBaudRate = CBR_56000
    ElseIf index = 11 Then
        GetBaudRate = CBR_57600
    ElseIf index = 12 Then
        GetBaudRate = CBR_115200
    ElseIf index = 13 Then
        GetBaudRate = CBR_128000
    ElseIf index = 14 Then
        GetBaudRate = CBR_256000
    End If

End Function

Public Function GetDataBits(index As Long) As Long

    GetDataBits = 8
    
    If index = 0 Then
        GetDataBits = 5
    ElseIf index = 1 Then
        GetDataBits = 6
    ElseIf index = 2 Then
        GetDataBits = 7
    ElseIf index = 3 Then
        GetDataBits = 8
    End If
End Function

Public Function GetBinaryMode(index As Long) As Boolean
    GetBinaryMode = False
    If index <> 0 Then
        GetBinaryMode = True
    End If
End Function

Public Function GetBaudIndex(baud As Long) As Long

    GetBaudIndex = 6
    
    If baud = CBR_110 Then
        GetBaudIndex = 0
    ElseIf baud = CBR_300 Then
        GetBaudIndex = 1
    ElseIf baud = CBR_600 Then
        GetBaudIndex = 2
    ElseIf baud = CBR_1200 Then
        GetBaudIndex = 3
    ElseIf baud = CBR_2400 Then
        GetBaudIndex = 4
    ElseIf baud = CBR_4800 Then
        GetBaudIndex = 5
    ElseIf baud = CBR_9600 Then
        GetBaudIndex = 6
    ElseIf baud = CBR_14400 Then
        GetBaudIndex = 7
    ElseIf baud = CBR_19200 Then
        GetBaudIndex = 8
    ElseIf baud = CBR_38400 Then
        GetBaudIndex = 9
    ElseIf baud = CBR_56000 Then
        GetBaudIndex = 10
    ElseIf baud = CBR_57600 Then
        GetBaudIndex = 11
    ElseIf baud = CBR_115200 Then
        GetBaudIndex = 12
    ElseIf baud = CBR_128000 Then
        GetBaudIndex = 13
    ElseIf baud = CBR_256000 Then
        GetBaudIndex = 14
    End If

End Function

Public Function GetDataBitsIndex(databits As Long) As Long

    GetDataBitsIndex = 3
    
    If databits = 5 Then
        GetDataBitsIndex = 0
    ElseIf databits = 6 Then
        GetDataBitsIndex = 1
    ElseIf databits = 7 Then
        GetDataBitsIndex = 2
    ElseIf databits = 8 Then
        GetDataBitsIndex = 3
    End If
End Function

Public Function GetParityIndex(parity As Long) As Long
    GetParityIndex = parity
    If parity > SPACEPARITY Then
        GetParityIndex = NOPARITY
    End If
End Function

Public Function GetStopBitsIndex(stopbits As Long) As Long
    GetStopBitsIndex = stopbits
    If stopbits > TWOSTOPBITS Then
        GetStopBitsIndex = ONESTOPBIT
    End If
End Function

Public Function GetFlowIndex(flow As Long) As Long
    GetFlowIndex = flow
    If flow > FLOW_XONOFF Then
        GetFlowIndex = FLOW_NONE
    End If
End Function

Public Function GetBinaryIndex(binmode As Boolean) As Long
    GetBinaryIndex = 0
    If binmode = True Then
        GetBinaryIndex = 1
    End If
End Function

